/**
 * Copyright Accenture 2006-2007. All rights reserved.
 *
 */
/**
 * 
 * Subversion meta data:
 * $Id$
 * $HeadURL$
 *
 */
package com.ats.platforms.domain;

/**
 * Class representing a plotting point with x and y coordinate 
 * including a RCD type (needed for differentiate the coloring of 
 * plottes points according to RCD status)
 * 
 * @author markus.lang
 * Created: 25.01.2007
 * 
 *
 */
public class PlotPoint {
    private int x = 0;
    private int y = 0;
    private int type = 0;
    
    /**
     * Full Constructor 
     * @param x
     * @param y
     * @param type
     */
    public PlotPoint(int x, int y, int type) {
        super();
        this.x = x;
        this.y = y;
        this.type = type;
    }
    
    /**
     * @return the type
     */
    public int getType() {
        return this.type;
    }
    /**
     * @param type the type to set
     */
    public void setType(int type) {
        this.type = type;
    }
    /**
     * @return the x
     */
    public int getX() {
        return this.x;
    }
    /**
     * @param x the x to set
     */
    public void setX(int x) {
        this.x = x;
    }
    /**
     * @return the y
     */
    public int getY() {
        return this.y;
    }
    /**
     * @param y the y to set
     */
    public void setY(int y) {
        this.y = y;
    }
}
